\animplay.xpl
include	c:\cxpl\codes;
string 0;

def LOBUFFSZ= 4*1024;
def MAXW=1280, MAXH=1024;
def IMGBUFFSIZE=MAXW*MAXH*4;

char CmdLine($80);
int CpuRegs, Dseg, DosBuff, NumArgs;
int ModeProp(4);
int Handle;
char ImgBuff(IMGBUFFSIZE);
int ImgW,ImgH,ImgDepth;
int Pal(256);
int DelayTime;
int Fatal;
int StopPlay;
	
func StrLen(Str);
char Str;
int Sz;
begin
	Sz:=0;	
	while Str(Sz)#0 do Sz:=Sz+1;	
	return Sz;
end;

proc ParseCmdLine;				
int I, J;
begin	
	I:=0;
	J:=0;
	NumArgs:=0;
	Blit(CpuRegs(11),$81,Dseg,CmdLine,$7f);
	while CmdLine(I)=$20 ! CmdLine(I)=$9 do I:=I+1;
	if CmdLine(I)=$d then 
	begin		
		CmdLine(0):=0;
		return;
	end;
	loop 
	begin
		repeat
		begin
			CmdLine(J):=CmdLine(I);
			J:=J+1;
			I:=I+1;
		end
		until CmdLine(I)=$20 ! CmdLine(I)=$9 ! CmdLine(I)=$d;
		
		NumArgs:=NumArgs+1;
		CmdLine(J):=0;
		J:=J+1;
		if CmdLine(I)=$d then return;
		while CmdLine(I)=$20 ! CmdLine(I)=$9 do I:=I+1;
		if CmdLine(I)=$d then return;
	end;
end;


func GetArg(ArgNo);
int ArgNo;
int I,J;
begin
	if ArgNo>NumArgs ! NumArgs=0 then return 0;
	if ArgNo=1 then return CmdLine;
	
	I:=0;
	J:=1;
	loop
	begin
		while CmdLine(I)#0 do I:=I+1;
		I:=I+1;
		J:=J+1;
		if ArgNo=J then return CmdLine+I
	end;
	
end;

func FileOp(File,Attr);
char File;
int Attr;
begin
	Blit(Dseg,File,DosBuff,0,StrLen(File)+1);
	CpuRegs(0):=$3d00 + (Attr & $ff);
	CpuRegs(9):=DosBuff;
	CpuRegs(3):=0;
	SoftInt($21);
	if CpuRegs(7)=false then return (CpuRegs(0) & $ffff)
	else return -1;
end;


func FileRd(Handle,Buffer,Size);
int Handle;
char Buffer;
int Size;
int BuffOffs,SzRd,TotRd;
begin
	TotRd:=0;
	BuffOffs:=Buffer;
	loop begin
		if (Size>0 & Size<LOBUFFSZ) then SzRd:=Size	
		else SzRd:=LOBUFFSZ;	
		CpuRegs(0):=$3f00;
		CpuRegs(1):=Handle;
		CpuRegs(2):=SzRd;
		CpuRegs(3):=0;	
		CpuRegs(9):=DosBuff;
		SoftInt($21);		
		if CpuRegs(7)=false then 
		begin
			CpuRegs(0):=CpuRegs(0) & $ffff;
			Blit(DosBuff,0,Dseg,BuffOffs,CpuRegs(0));
			TotRd:=TotRd+CpuRegs(0);
			Size:=Size-SzRd;
			if Size=0 ! (SzRd # CpuRegs(0)) then quit;
			BuffOffs:=BuffOffs+SzRd;
		end
		else quit 
	end;
	return TotRd;	
end;

func FileSeek(Handle,Offset,Origin);
int Handle,Offset,Origin;
begin
	CpuRegs(0):=$4200 ! Origin;
	CpuRegs(1):=Handle;
	CpuRegs(2):=Offset>>16;
	CpuRegs(3):=Offset & $ffff;
	SoftInt($21);
	if CpuRegs(7)=false then return ((CpuRegs(3)<<16) + (CpuRegs(0) & $ffff))
	else return -1;

end;

func FileCl(Handle);
int Handle;
begin
	CpuRegs(0):=$3e00;
	CpuRegs(1):=Handle;
	SoftInt($21);	
	if CpuRegs(7)=false then return true
	else return false;
end;


func FindMode;
def NUMMODES=21;
int VideoModes,I;
begin
	VideoModes:=[[$013, 320, 200, 8],
		     [$100, 640, 400, 8], 
		     [$101, 640, 480, 8],
		     [$103, 800, 600, 8],
		     [$105,1024, 768, 8],
		     [$107,1280,1024, 8],
		     [$10d, 320, 200,15],
		     [$10e, 320, 200,16],
		     [$10f, 320, 200,24],
		     [$110, 640, 480,15],
		     [$111, 640, 480,16],
		     [$112, 640, 480,24],
		     [$113, 800, 600,15],
		     [$114, 800, 600,16],
		     [$115, 800, 600,24],
		     [$116,1024, 768,15],
		     [$117,1024, 768,16],
		     [$118,1024, 768,24],
		     [$119,1280,1024,15],
		     [$11a,1280,1024,16],
		     [$11b,1280,1024,24]];
		
	
	if ImgW>MAXW ! ImgH>MAXH then return false;

	for I:=0,NUMMODES-1 do
	begin
		if ((VideoModes(I,1)>=ImgW)  & 
		    (VideoModes(I,2)>=ImgH)  & 
		    (VideoModes(I,3)>=ImgDepth)) then
		begin
			ModeProp(0):=VideoModes(I,0);
			ModeProp(1):=VideoModes(I,1);
			ModeProp(2):=VideoModes(I,2);
			ModeProp(3):=VideoModes(I,3);
			return true;
		end;
	end;

	return false;
end;

proc	WaitSync;			
begin
	while port($3DA) & $08 do;	
	repeat until port($3DA) & $08
end;

proc SetPal(FirstCol, NumCol, Is6bit);
int FirstCol,NumCol,Is6bit;
int I;
begin
	WaitSync;
	port($3C8):= FirstCol;
	if Is6bit=true then
	begin
		for I:=FirstCol, NumCol-1 do
		begin
			port($3C9):=Pal(I);
			port($3C9):=Pal(I)>>8;
			port($3C9):=Pal(I)>>16;
		end;
	end
	else
	begin
		for I:=FirstCol, NumCol-1 do
		begin
			port($3C9):=Pal(I)>>2;
			port($3C9):=Pal(I)>>10;
			port($3C9):=Pal(I)>>18;
		end;
	end
end;


proc	OpenTimer;		
begin
	port($43):= $34;		
	port($40):= $FF;		
	port($40):= $FF;		
end;	

proc	CloseTimer;		
begin
	port($43):= $36;
	port($40):= $FF;			
	port($40):= $FF;			
end;		

func	GetTimeX;		
int	T;
begin				
	port($43):= 0;			
	T:= port($40) + port($40)<<8;	
	return T | $0000FFFF;
end;

proc DelayMsec;
int T;
begin
	T:=GetTimeX;
	repeat until ((GetTimeX-T) & $FFFF) >= 1193;		
end;

proc WaitNextFrame(Msec,NoWS);
int Msec;
int NoWS;
int Wait,I;
begin
	if NoWS=true then
	begin
		if Msec>14 then Msec:=Msec-14
		else Msec:=1;
	end;
	for I:=0, Msec-1 do DelayMsec;
end;

proc SetMem(Buffer,Value,Size);
char Buffer;
int Value,Size;
begin

asm	{
	mov edi,Buffer
	mov al,Value
	mov ecx,Size
	mov ebx,ecx
	and ebx,3
	shr ecx,2
	or ecx,ecx
	jz @@1
	mov ah,al
	mov dx,ax
	shl eax,16
	mov ax,dx
	rep stosd
@@1:
	or ebx,ebx
	jz @@2
	mov ecx,ebx
	rep stosb
@@2:	
	}
end;


func SWapW(Val);
int Val;
begin
	
	return (Val<<8 & $ff00)+(Val>>8 & $ff);

end;

func SWapD(Val);
int Val;
begin	
	return SwapW(Val)<<16 + SwapW(Val>>16);

end;


proc ShowFrame;
char Image;
begin
	WaitSync;
	Paint((ModeProp(1)-ImgW)/2,(ModeProp(2)-ImgH)/2,ImgW,ImgH,Image,ImgW);
end;


func PlayIFF;
def FORM=$4d524f46, ANIM=$4d494e41, ILBM=$4d424c49;
def HAM=$800,EHB=$80;
def FORMHDR=12;
int IFFFormT(FORMHDR/4),IFFFormSz;
int Depth,Mask,Compressed,Colors;
int BytesPPix, BytesPRow, CamgType;
int IsAnim,ImgSz,ImgPt,IsHam;
int NumFrames,Frame,FirstTime;
int HaveBMHD,HaveBODY,HaveCMAP,HaveDLTA;
int Operation,AnhdMask,BW,BH,PX,PY,DeltaBits;

func DeCompLineBrun1(DestAddr,SrcAddr,Sz);
char DestAddr,SrcAddr;
int Sz;
char B1,B2;
int StartAddr,I;
begin
	I:= 0;
	StartAddr:=SrcAddr;
	repeat
		B1:=SrcAddr(0);
		SrcAddr:=SrcAddr+1;
		if B1 <= $7F then
		begin
			B1:=B1+1;			
			Blit(Dseg,SrcAddr,DSeg,DestAddr,B1);		
			SrcAddr:=SrcAddr+B1;
		end
		else	
		begin	
			B1:= (-B1 & $ff)+1;
			B2:= SrcAddr(0);
			SetMem(DestAddr,B2,B1);
			SrcAddr:=SrcAddr+1;
		end;
		I:=I+B1;
		DestAddr:=DestAddr+B1;
	until I>=Sz;

	return SrcAddr-StartAddr;
end;


proc BGR32toRGB32(DestAddr,SrcAddr,Sz);
int DestAddr;
int SrcAddr;
int Sz;
int I;
begin
	for I:=0, Sz-1 do
	begin
		DestAddr(I):=((SrcAddr(I) & $ff)<<16)+ (SrcAddr(I) & $00ff00) + ((SrcAddr(I)>>16) & $ff);
	end;
end;


proc HAMtoRGB(Buffer,Width,Height);
int Buffer;
int Width,Height;
int Val;
char R,G,B;
int HAMMode,HAMData,DMask,SF1,SF2;
int I,J;
begin
	SF1:=Depth-2;
	SF2:=8-SF1;
	DMask:=(1<<SF1)-1;

	for J:=0, Height-1 do
	begin		
		
		R:=0; 		
		G:=0;	
		B:=0;	
		for I:=0, Width-1 do	
		begin
			Val:=Buffer(I)>>24;
			HAMMode:=Val>>SF1;
			HAMData:=Val & DMask;	
			case HAMMode  of		
			0:
			begin
				R:=Pal(HAMData) & $0000ff;			
				G:=(Pal(HAMData) & $00ff00)>>8;
				B:=(Pal(HAMData) & $ff0000)>>16;
			end;	
			1: B:=HAMData<<SF2;
			2: R:=HAMData<<SF2;
			3: G:=HAMData<<SF2
			other[];
		
			Buffer(I):=(Buffer(I) & $ff000000) + R<<16 + G<<8 + B;

		end;	
		
		Buffer:=Buffer+BytesPRow;
	end;	

end;


proc SetPalEHB;
char R,G,B;
int I;
begin
	for I:=0,31 do
	begin
		R:=(Pal(I) & $ff)>>1;
		G:=((Pal(I)>>8) & $ff)>>1;
		B:=((Pal(I)>>16)& $ff)>>1;
		Pal(I+32):=R + G<<8 + B<<16;
	end;
	SetPal(0,Colors*2,false);
end;

proc SetIFFPal;
begin
	if CAMGType=0 then SetPal(0,Colors,false)	
	else 
	begin
		if (CAMGType & EHB)=EHB then SetPalEHB
		else 
		begin
			if IsHam=false then SetPal(0,Colors,false)
		end;
	end;
end;


func InitIFFPlay;
begin
	if (((CAMGType & HAM)=HAM) & ((Depth=6) ! (Depth=8))) ! 
		((CamgType=0) & (Depth=6)) then IsHam:=true
	else IsHam:=false;
	BytesPPix:=(Depth+7)/8;
	if IsHam=false then
	begin
		ImgDepth:=Depth; 
		if BytesPPix=3 then BytesPPix:=4;
	end
	else
	begin
		ImgDepth:= 24;
		BytesPPix:= 4;
	end;
	BytesPRow:=ImgW*BytesPPix;
	ImgSz:=BytesPRow*ImgH;
	
	if FindMode=false then return false;
	SetVid(ModeProp(0));
	return true;

end;

func DOBODY(Sz,DestBuffer);
int Sz;
char DestBuffer;
char BODYBuff;
int WLine,RWLine,SF;
char LineBuff,PlaneAddr;
char PicData,PDCpy;
int Plane,I,J,K,L;
char Ch;
begin
	BODYBuff:=Reserve(Sz);
	if FileRd(Handle,BODYBuff,Sz)#Sz then return false;
	WLine:=2*((ImgW+15)/16);
	RWLine:=WLine*Depth;	

	if Compressed=1 then LineBuff:=Reserve(RWLine);
	PicData:=Reserve(BytesPRow);
	
	for I:=0, ImgH-1 do
	begin
		if Compressed=1 then 
		begin
			BODYBuff:=BODYBuff+DeCompLineBrun1(LineBuff,BODYBuff,RWLine);
			
		end
		else
		begin	 
			LineBuff:=BODYBuff;
			BODYBuff:=BODYBuff+RWLine;
		end;
		
		SetMem(PicData,0,BytesPRow);
		
		if IsHam=false then PDCpy:=PicData
		else PDCpy:=PicData+3;
		
		PlaneAddr:=LineBuff;
		for Plane:=0, Depth-1 do
		begin
			L:=Plane/8;	
			SF:=Rem(Plane/8);
			for J:=0,WLine-1 do
			begin
				Ch:=PlaneAddr(J);
				for K:=0, 8-1 do
				begin
					if (Ch & $80) =$80 then
						if L<BytesPRow then
							PDCpy(L):=PDCpy(L) ! 1<<SF;
					Ch:=Ch<<1;
					L:=L+BytesPPix;
				end;	
			end;
			PlaneAddr:=PlaneAddr+WLine;
		end;
		
		if Mask=1 then
		begin
			if Compressed=1 then 
			begin
				BODYBuff:=BODYBuff+DeCompLineBrun1(LineBuff,BODYBuff,RWLine);
			end
			else
			begin	 
				BODYBuff:=BODYBuff+RWLine;
			end		
		
		end;
		if Depth<=8 then Blit(DSeg,PicData,DSeg,DestBuffer+BytesPRow*I,BytesPRow)	
		else BGR32toRGB32(DestBuffer+(ImgW<<2)*I,PicData,ImgW);
	end;
	return true;
end;

func DOBMHD(Sz);
int Sz;
int BMHDBuff;
begin
	BMHDBuff:=Reserve(Sz);
	if FileRd(Handle,BMHDBuff,Sz)#Sz then return false;
	ImgW:=SwapW(BMHDBuff(0) & $ffff);
	ImgH:=SwapW(BMHDBuff(0)>>16);
	Depth:=BMHDBuff(2) & $ff;
	Mask:=(BMHDBuff(2)>>8) & $ff;
	Compressed:=(BMHDBuff(2)>>16) & $ff;
	return true;
end;

func DOCMAP(Sz,Palette);
int Sz;
int Palette;
char CMAPBuff;
int Index,I;
begin
	CMAPBuff:=Reserve(Sz);
	if FileRd(Handle,CMAPBuff,Sz)#Sz then return false;
	Index:=0;
	Colors:=Sz/3;
	SetMem(Palette,0,(Colors-1)*4);
	for I:=0, Colors-1 do
	begin
		Palette(Index):=CMAPBuff(2)<<16+CMAPBuff(1)<<8+CMAPBuff(0);
		CMAPBuff:=CMAPBuff+3; 
		Index:=Index+1;
	end;
	return true;
end;


func DOCAMG(Sz);
int Sz;
int CAMGBuff;
begi
	CAMGBuff:=Reserve(Sz);
	if FileRd(Handle,CAMGBuff,Sz)#Sz then return false;
	CamgType:=SWapD(CAMGBuff(0));
	return true;
end;


func DOANHD(Sz);
int Sz;
int ANHDBuff;
begin
	ANHDBuff:=Reserve(Sz);
	if FileRd(Handle,ANHDBuff,Sz)#Sz then return false;
	Operation:=ANHDBuff(0) & $ff;
	AnhdMask:=(ANHDBuff(0)>>8) & $ff;
	BW:=SwapW(ANHDBuff(0)>>16);
	BH:=SwapW(ANHDBuff(1) & $ffff);
	PX:=SwapW(ANHDBuff(1)>>16);
	PY:=SwapW(ANHDBuff(2) & $ffff);
	DelayTime:=SwapD(((ANHDBuff(3)>>16) & $ffff) + ((ANHDBuff(4)<<16)&$ffff0000)) * 17;
	DeltaBits:=SwapD(ANHDBuff(5));
	return true;
end;

func DODPAN(Sz);
int Sz;
int DPANBuff;
begin
	DPANBuff:=Reserve(Sz);
	if FileRd(Handle,DPANBuff,Sz)#Sz then return false;
	NumFrames:=SwapD(DPANBuff(0)) & $ffff;
	return true;
end;

proc DELTA5(SrcBuffer,DestBuffer);
char SrcBuffer;
char DestBuffer;
int Plane,PlanePtr;
int Columns,SF;
char Offset,DBuff;
char OpCount,Op,Cnt,Ch,I,J,K;
begin	
	
	if IsHam=true then DestBuffer:=DestBuffer+3;
	Columns:=ImgW>>3;
	for Plane:=0,Depth-1 do
	begin
		SF:=1<<Plane;
		PlanePtr:=SrcBuffer+(Plane<<2);
		Offset:=SwapD(PlanePtr(0));
		if Offset#0 then
		begin
			Offset:=SrcBuffer+Offset;
			for I:=0, Columns-1 do
			begin
				DBuff:=DestBuffer+((I<<3)*BytesPPix);
				OpCount:=Offset(0);
				Offset:=Offset+1;
				loop
				begin
					if OpCount=0 then quit;
					Op:=Offset(0);
					Offset:=Offset+1;
					if (Op & $80)#$80 then
					begin
						if Op#0 then DBuff:=DBuff+Op*BytesPRow
						else
						begin
							Cnt:=Offset(0);
							Offset:=Offset+1;
							Op:=Offset(0);
							Offset:=Offset+1;
							loop 
							begin
								if Cnt=0 then quit;
								Ch:=Op;
								K:=0;
								for J:=0, 8-1 do
								begin
									if (Ch & $80) =$80 then 
										DBuff(K):=DBuff(K) ! SF		
									else
										DBuff(K):=DBuff(K) & ~SF;
									
									Ch:=Ch<<1;
									K:=K+BytesPPix;
								end;
								DBuff:=DBuff+BytesPRow;
								Cnt:=Cnt-1;
							end;
						end;
					end
					else
					begin
						Cnt:=Op & $7f;
						loop 
						begin
							if Cnt=0 then quit;
							Ch:=Offset(0);
							Offset:=Offset+1;
							K:=0;
							for J:=0, 8-1 do
							begin
								if (Ch & $80) =$80 then
									DBuff(K):=DBuff(K) ! SF
								else
									DBuff(K):=DBuff(K) & ~SF;	
								
								Ch:=Ch<<1;
								K:=K+BytesPPix;
							end;
							DBuff:=DBuff+BytesPRow;
							Cnt:=Cnt-1;						
						end;						
					end;
					OpCount:=Opcount-1;
				end;
			end;
		end;
	end;
end;

proc DELTA7(SrcBuffer,DestBuffer);
char SrcBuffer;
char DestBuffer;
char DBuff;
int Columns,SF1,SF2;
int Plane,OpLstPtr,PlanePtr,PlaneOffs;
char OpOffs,OpCount,Op,Cnt;
int Val,ValCpy,Bits,NumB;
int I,J,K;
begin
	if IsHam=true then DestBuffer:=DestBuffer+3;
	
	if (DeltaBits & 1)=1 then 
	begin
		Bits:=32;
		SF2:=5;
		NumB:=4;
	end
	else 
	begin
		Bits:=16;
		SF2:=4;
		NumB:=2;
	end;

	Columns:=ImgW>>SF2;

	for Plane:=0,Depth-1 do
	begin
		SF1:=1<<Plane;
		OpLstPtr:=SrcBuffer+(Plane<<2);
		PlanePtr:=OpLstPtr+32;
		OpOffs:=SwapD(OpLstPtr(0));		
		if OpOffs#0 then
		begin
			PlaneOffs:=SrcBuffer+SwapD(PlanePtr(0));
			OpOffs:=SrcBuffer+OpOffs;
			for I:=0, Columns-1 do
			begin
				DBuff:=DestBuffer+((I<<SF2)*BytesPPix);
				OpCount:=OpOffs(0);
				OpOffs:=OpOffs+1;
				loop
				begin
					if OpCount=0 then quit;
					Op:=OpOffs(0);
					OpOffs:=OpOffs+1;
					if (Op & $80)#$80 then
					begin
						if Op#0 then DBuff:=DBuff+Op*BytesPRow
						else
						begin
							Cnt:=OpOffs(0);
							OpOffs:=OpOffs+1;
							if Bits=32 then
								ValCpy:=SwapD(PlaneOffs(0))
							else
								ValCpy:=SwapW(PlaneOffs(0))<<16;
							PlaneOffs:=PlaneOffs+NumB;
							
							loop 
							begin
								if Cnt=0 then quit;
								Val:=ValCpy;
								K:=0;
								for J:=0, Bits-1 do
								begin
									if (Val & $80000000)=$80000000 then 
										DBuff(K):=DBuff(K) ! SF1		
									else
										DBuff(K):=DBuff(K) & ~SF1;
									Val:=Val<<1;
									K:=K+BytesPPix;
								end;
								DBuff:=DBuff+BytesPRow;
								Cnt:=Cnt-1;
							end;		
						end;
					end
					else
					begin
						Cnt:=Op & $7f;
						loop 
						begin
							if Cnt=0 then quit;
							if Bits=32 then
								Val:=SwapD(PlaneOffs(0))
							else
								Val:=SwapW(PlaneOffs(0))<<16;
							PlaneOffs:=PlaneOffs+NumB;		
							K:=0;
							for J:=0, Bits-1 do
							begin
								if (Val & $80000000)=$80000000 then
									DBuff(K):=DBuff(K) ! SF1
								else
									DBuff(K):=DBuff(K) & ~SF1;	
								
								Val:=Val<<1;
								K:=K+BytesPPix;
							end;
							DBuff:=DBuff+BytesPRow;
							Cnt:=Cnt-1;						
						end;						
					end;
					OpCount:=Opcount-1;
				end;

			end;
		end;
	end;
end;

proc DELTA8(SrcBuffer,DestBuffer);
char SrcBuffer;
char DestBuffer;
char DBuff;
int Columns,SF1,SF2;
int Plane,OpLstPtr;
int OpOffs,OpCount,Op,Cnt;
int Val,ValCpy,Bits,NumB,Mask;
int I,J,K;
begin
	if IsHam=true then DestBuffer:=DestBuffer+3;
	
	if (DeltaBits & 1)=1 then 
	begin
		Bits:=32;
		SF2:=5;
		NumB:=4;
		Mask:=$80000000;
	end
	else 
	begin
		Bits:=16;
		SF2:=4;
		NumB:=2;
		Mask:=$8000;
	end;

	Columns:=ImgW>>SF2;

	for Plane:=0,Depth-1 do
	begin
		SF1:=1<<Plane;
		OpLstPtr:=SrcBuffer+(Plane<<2);
		OpOffs:=SwapD(OpLstPtr(0));		
		if OpOffs#0 then
		begin
			OpOffs:=SrcBuffer+OpOffs;
			for I:=0, Columns-1 do
			begin
				DBuff:=DestBuffer+((I<<SF2)*BytesPPix);
				if Bits=32 then
					OpCount:=SwapD(OpOffs(0))
				else
					OpCount:=SwapW(OpOffs(0));
				OpOffs:=OpOffs+NumB;
				loop
				begin
					if OpCount=0 then quit;
					if Bits=32 then
						Op:=SwapD(OpOffs(0))
					else
						Op:=SwapW(OpOffs(0));
					OpOffs:=OpOffs+NumB;
					
					if (Op & Mask)#Mask then
					begin
						if Op#0 then DBuff:=DBuff+Op*BytesPRow
						else
						begin
							if Bits=32 then
							begin
								Cnt:=SwapD(OpOffs(0));
								OpOffs:=OpOffs+4;
								ValCpy:=SwapD(OpOffs(0));

							end
							else
							begin
								Cnt:=SwapW(OpOffs(0));
								OpOffs:=OpOffs+2;
								ValCpy:=SwapW(OpOffs(0))<<16;
							end;
							OpOffs:=OpOffs+NumB;
							loop 
							begin
								if Cnt=0 then quit;
								Val:=ValCpy;
								K:=0;
								for J:=0, Bits-1 do
								begin
									if (Val & $80000000)=$80000000 then 
										DBuff(K):=DBuff(K) ! SF1		
									else
										DBuff(K):=DBuff(K) & ~SF1;
									Val:=Val<<1;
									K:=K+BytesPPix;
								end;
								DBuff:=DBuff+BytesPRow;
								Cnt:=Cnt-1;
							end;		
						end;
					end
					else
					begin
						Cnt:=Op & (Mask-1);
						loop 
						begin
							if Cnt=0 then quit;
							if Bits=32 then
								Val:=SwapD(OpOffs(0))
							else
								Val:=SwapW(OpOffs(0))<<16;
							OpOffs:=OpOffs+NumB;		
							K:=0;
							for J:=0, Bits-1 do
							begin
								if (Val & $80000000)=$80000000 then
									DBuff(K):=DBuff(K) ! SF1
								else
									DBuff(K):=DBuff(K) & ~SF1;	
								
								Val:=Val<<1;
								K:=K+BytesPPix;
							end;
							DBuff:=DBuff+BytesPRow;
							Cnt:=Cnt-1;						
						end;						
					end;
					OpCount:=Opcount-1;
				end;

			end;
		end;
	end;
end;

func DODLTA(Sz,Buff);
int Sz;
char Buff;
char DLTABuff;
begin
	if Operation=0 then return DOBODY(Sz,Buff)
	else 
	begin	
		DLTABuff:=Reserve(Sz);
		if FileRd(Handle,DLTABuff,Sz)#Sz then return false;
		case Operation of
		1:[];
		2:[];
		3:[];
		4:[];
		5: DELTA5(DLTABuff,Buff);
		6:[];		
		7: DELTA7(DLTABuff,Buff);
		8: DELTA8(DLTABuff,Buff)		
		other[];
	end; 

	return true;
end;

func DOILBM(Sz);
int Sz;
def BMHD=$44484d42,CMAP=$50414d43,BODY=$59444f42;
def ANHD=$44484e41,DLTA=$41544c44,CAMG=$474d4143;
def DPAN=$4e415044;
def CHNKHDR=8;
int ChnkT(CHNKHDR/4);
int ChnkSz,I;
begin	
	HaveCmap:=false;
	repeat
		if FileRd(Handle,ChnkT,CHNKHDR)#CHNKHDR then return false;
		ChnkSz:=SwapD(ChnkT(1));
		if (ChnkSz & 1)=1 then ChnkSz:=ChnkSz+1;
		case ChnkT(0) of
			BMHD: 
			begin
				if DOBMHD(ChnkSz)=false then return false;
				HaveBMHD:=true;
			end;
			BODY: 
			begin
				if (HaveBMHD=true) then
				begin  
					if (FirstTime=true) & (Frame=0) then 					
					begin
						if InitIFFPlay=false then return false;
					end;
					ImgPt:=ImgBuff;
					SetMem(ImgBuff,0,ImgSz);
					SetMem(ImgBuff+ImgSz,0,ImgSz);
					if DOBODY(ChnkSz,ImgPt)=false then return false;
					HaveBODY:=true;
				end
				else return false;
			end;
			CMAP: 
			begin	
				if DOCMAP(ChnkSz,Pal)=false then return false;
				HaveCMAP:=true;
			end;
			CAMG: 
			begin
				if DOCAMG(ChnkSz)=false then return false
			end;	
			ANHD: 
			begin
				if DOANHD(ChnkSz)=false then return false;
			end;
			DLTA: 
			begin
				if (Frame=1) then 
					Blit(Dseg,ImgBuff,DSeg,ImgBuff+ImgSz,ImgSz);

				if ImgPt=ImgBuff then ImgPt:=ImgBuff+ImgSz
				else ImgPt:=ImgBuff; 
			
				if DODLTA(ChnkSz,ImgPt)=false then return false;				
				HaveDlta:=true;
			end;
			DPAN:
			begin
				if DODPAN(ChnkSz)=false then return false;
			end
			other FileSeek(Handle,ChnkSz,1);
		Sz:=Sz-(ChnkSz+CHNKHDR);
	until Sz<=0;
	
	if (HaveBODY=false) & (HaveDlta=false) then return false;
	
	if IsHam=false then 
	begin
		if (HaveCMAP=true) then SetIFFPal;
	end
	else HAMtoRGB(ImgPt,ImgW,ImgH);
	
	ShowFrame(ImgPt);
	WaitNextFrame(DelayTime,false);
	
	HaveCmap:=false;
	return true;
end;

func ShowILBM(Sz);
int Sz;
begin
	IsAnim:=false;
	if DOILBM(Sz)=false then return false;
	while ChkKey#true do;
	SetVid($3);
	return true;
end;

func DOANIM(Sz);
int Sz;
int ANIMFormT(FORMHDR/4),ANIMFormSz;
int OffsetLoop;
begin	
	IsAnim:=true;
	NumFrames:=-1;
	StopPlay:=false;
	loop
	begin
		repeat	
		if FileRd(Handle,ANIMFormT,FORMHDR)#FORMHDR ! ANIMFormT(0)#FORM then StopPlay:=true
		else
		begin
			ANIMFormSz:=SwapD(ANIMFormT(1))-4;
			if ANIMFormT(2)=ILBM then 
			begin				
				if DOILBM(ANIMFormSz)=false then StopPlay:=true;
				if (Frame=0) then OffsetLoop:=Sz;
				Frame:=Frame+1;
			end
			else FileSeek(Handle,ANIMFormSz,1);
			if ChkKey=true then 
			begin
				Chin(1);
				StopPlay:=true;
			end;			
			Sz:=Sz-(ANIMFormSz+FORMHDR);
		end;
		until ((Frame=NumFrames) ! (Sz<=0) ! (StopPlay=true));	
		if StopPlay=true then quit;
		FileSeek(Handle,-OffsetLoop,2);
		Sz:=OffsetLoop;
		FirstTime:=false;
		Frame:=0;
		DelayTime:=0;
			
	end;
	SetVid($3);
	return true;
end;

begin
	HaveBODY:=false;
	HaveBMHD:=false;
	HaveDLTA:=false;
	FirstTime:=true;
	CamgType:=0;
	DelayTime:=0;
	Frame:=0;
	if FileRd(Handle,IFFFormT,FORMHDR)#FORMHDR ! IFFFormT(0)#FORM then return false;
	IFFFormSz:=SwapD(IFFFormT(1))-4;
	if IFFFormT(2)=ILBM then return ShowILBM(IFFFormSz)
	else if IFFFormT(2)=ANIM then return DOANIM(IFFFormSz)
	else return false;
end;

proc 	InitProgram;
begin	
	CpuRegs:=GetReg;
	Dseg:=CpuRegs(12);
	ParseCmdLine;
	if NumArgs=0 then 
	begin
		Text(0,"No file passed as argument...");
		CrLf(0);
		exit($ff);
	end;
	DosBuff:=Malloc(LOBUFFSZ/16);	
	Handle:=FileOp(GetArg(1),0);
	if Handle=-1 then
	begin
		Text(0,"Open file error...");
		CrLf(0);
		Release(DosBuff);
		exit($ff);
	end;
	OpenTimer;
end;

proc   	CloseProgram(ExitVal);
int 	ExitVal;
begin
	CloseTimer;
	FileCl(Handle);
	Release(DosBuff);
	if ExitVal= -1	then
	begin
		Text(0,"Can't show this file...");
		CrLf(0);
	end;
	exit(ExitVal);
end;


begin	\Main
	InitProgram;
	if PlayIFF=true then CloseProgram(0);
	CloseProgram(-1);
end;
